"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireWildcard(require("react"));
var _reactNativeReanimated = _interopRequireWildcard(require("react-native-reanimated"));
var _reactNative = require("react-native");
var _useTimer = _interopRequireDefault(require("./useTimer"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
const DEFAULT_ANIMATION_DELAY = 0;
const DEFAULT_ANIMATION_DISTANCE = 80;
const DEFAULT_ANIMATION_DURATION = 200;
function Stopwatch(_ref, ref) {
  let {
    animationDelay = DEFAULT_ANIMATION_DELAY,
    animationDistance = DEFAULT_ANIMATION_DISTANCE,
    animationDuration = DEFAULT_ANIMATION_DURATION,
    containerStyle,
    enterAnimationType = 'slide-in-up',
    digitStyle,
    initialTimeInMs,
    leadingZeros = 1,
    onFinish,
    separatorStyle,
    textCharStyle,
    trailingZeros = 1
  } = _ref;
  const {
    tensOfMs,
    lastDigit,
    tens,
    minutes,
    play,
    reset,
    pause,
    getSnapshot
  } = (0, _useTimer.default)(initialTimeInMs, onFinish);
  (0, _react.useImperativeHandle)(ref, () => ({
    play,
    pause,
    reset,
    getSnapshot
  }));
  const isSecondsDigitMounted = (0, _reactNativeReanimated.useSharedValue)(false);
  const isTensOfSecondsDigitMounted = (0, _reactNativeReanimated.useSharedValue)(false);
  const isMinutesDigitMounted = (0, _reactNativeReanimated.useSharedValue)(false);
  const createEntering = isFirstRender => values => {
    'worklet';

    if (!isFirstRender.value) {
      // Skip entering animation on first render
      isFirstRender.value = true;
      return {
        initialValues: {},
        animations: {}
      };
    }
    const animations = {
      originY: (0, _reactNativeReanimated.withDelay)(animationDelay, (0, _reactNativeReanimated.withTiming)(values.targetOriginY, {
        duration: animationDuration
      }))
    };
    const enterDirection = enterAnimationType === 'slide-in-up' ? -1 : 1;
    const initialValues = {
      originY: values.targetOriginY + animationDistance * enterDirection
    };
    return {
      initialValues,
      animations
    };
  };
  const exiting = values => {
    'worklet';

    const exitDirection = enterAnimationType === 'slide-in-up' ? 1 : -1;
    const animations = {
      originY: (0, _reactNativeReanimated.withDelay)(animationDelay, (0, _reactNativeReanimated.withTiming)(values.currentOriginY + animationDistance * exitDirection, {
        duration: animationDuration
      }))
    };
    const initialValues = {
      originY: values.currentOriginY
    };
    return {
      initialValues,
      animations
    };
  };

  // eslint-disable-next-line @typescript-eslint/no-unused-vars
  const {
    width,
    ...textCharStyleWithoutWidth
  } = _reactNative.StyleSheet.flatten(textCharStyle || {});
  return /*#__PURE__*/_react.default.createElement(_reactNative.View, {
    style: [styles.container, containerStyle]
  }, leadingZeros === 2 && /*#__PURE__*/_react.default.createElement(_reactNative.Text, {
    style: [styles.defaultCharStyle, textCharStyleWithoutWidth, digitStyle]
  }, "0"), /*#__PURE__*/_react.default.createElement(_reactNativeReanimated.default.Text, {
    key: `${minutes}-minutes`,
    style: [styles.defaultCharStyle, textCharStyleWithoutWidth, digitStyle],
    entering: createEntering(isMinutesDigitMounted),
    exiting: exiting
  }, minutes), /*#__PURE__*/_react.default.createElement(_reactNative.Text, {
    style: [styles.defaultCharStyle, textCharStyleWithoutWidth, separatorStyle]
  }, ":"), /*#__PURE__*/_react.default.createElement(_reactNativeReanimated.default.Text, {
    key: `${tens}-tens`,
    style: [styles.defaultCharStyle, textCharStyleWithoutWidth, digitStyle],
    entering: createEntering(isTensOfSecondsDigitMounted),
    exiting: exiting
  }, tens), /*#__PURE__*/_react.default.createElement(_reactNativeReanimated.default.Text, {
    key: `${lastDigit}-count`,
    style: [styles.defaultCharStyle, textCharStyleWithoutWidth, digitStyle],
    entering: createEntering(isSecondsDigitMounted),
    exiting: exiting
  }, lastDigit), trailingZeros > 0 && /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement(_reactNative.Text, {
    style: [styles.defaultCharStyle, textCharStyleWithoutWidth, separatorStyle]
  }, ","), /*#__PURE__*/_react.default.createElement(_reactNative.Text, {
    style: [styles.defaultCharStyle, textCharStyleWithoutWidth, digitStyle]
  }, tensOfMs >= 10 ? String(tensOfMs).charAt(0) : 0), trailingZeros === 2 && /*#__PURE__*/_react.default.createElement(_reactNative.Text, {
    style: [styles.defaultCharStyle, textCharStyleWithoutWidth, digitStyle]
  }, tensOfMs >= 10 ? String(tensOfMs).charAt(1) : String(tensOfMs).charAt(0))));
}
const styles = _reactNative.StyleSheet.create({
  container: {
    flexDirection: 'row',
    alignItems: 'center',
    overflow: 'hidden'
  },
  defaultCharStyle: {
    textAlign: 'center'
  }
});
const StopwatchTimer = /*#__PURE__*/(0, _react.forwardRef)(Stopwatch);
var _default = StopwatchTimer;
exports.default = _default;
//# sourceMappingURL=StopwatchTimer.js.map